#ifndef DEFINE_FUNC_ATTRIBUTES
# define DEFINE_FUNC_ATTRIBUTES
#endif
#include "nvim/func_attr.h"
#undef DEFINE_FUNC_ATTRIBUTES
listitem_T *tv_list_item_alloc(void) FUNC_ATTR_NONNULL_RET FUNC_ATTR_MALLOC;  // eval/typval.c:55
void tv_list_item_free(listitem_T *const item) FUNC_ATTR_NONNULL_ALL;  // eval/typval.c:66
void tv_list_item_remove(list_T *const l, listitem_T *const item) FUNC_ATTR_NONNULL_ALL;  // eval/typval.c:79
void tv_list_watch_add(list_T *const l, listwatch_T *const lw) FUNC_ATTR_NONNULL_ALL;  // eval/typval.c:92
void tv_list_watch_remove(list_T *const l, listwatch_T *const lwrem) FUNC_ATTR_NONNULL_ALL;  // eval/typval.c:105
void tv_list_watch_fix(list_T *const l, const listitem_T *const item) FUNC_ATTR_NONNULL_ALL;  // eval/typval.c:124
list_T *tv_list_alloc(void) FUNC_ATTR_NONNULL_RET;  // eval/typval.c:141
void tv_list_free_contents(list_T *const l) FUNC_ATTR_NONNULL_ALL;  // eval/typval.c:159
void tv_list_free_list(list_T *const l) FUNC_ATTR_NONNULL_ALL;  // eval/typval.c:179
void tv_list_free(list_T *const l) FUNC_ATTR_NONNULL_ALL;  // eval/typval.c:201
void tv_list_unref(list_T *const l);  // eval/typval.c:215
void tv_list_remove_items(list_T *const l, listitem_T *const item, listitem_T *const item2) FUNC_ATTR_NONNULL_ALL;  // eval/typval.c:231
void tv_list_insert(list_T *const l, listitem_T *const ni, listitem_T *const item) FUNC_ATTR_NONNULL_ARG(1, 2);  // eval/typval.c:260
void tv_list_insert_tv(list_T *const l, typval_T *const tv, listitem_T *const item);  // eval/typval.c:290
void tv_list_append(list_T *const l, listitem_T *const item) FUNC_ATTR_NONNULL_ALL;  // eval/typval.c:303
void tv_list_append_tv(list_T *const l, typval_T *const tv) FUNC_ATTR_NONNULL_ALL;  // eval/typval.c:325
void tv_list_append_list(list_T *const list, list_T *const itemlist) FUNC_ATTR_NONNULL_ARG(1);  // eval/typval.c:337
void tv_list_append_dict(list_T *const list, dict_T *const dict) FUNC_ATTR_NONNULL_ARG(1);  // eval/typval.c:355
void tv_list_append_string(list_T *const l, const char *const str, const ptrdiff_t len) FUNC_ATTR_NONNULL_ARG(1);  // eval/typval.c:376
void tv_list_append_allocated_string(list_T *const l, char *const str) FUNC_ATTR_NONNULL_ARG(1);  // eval/typval.c:396
void tv_list_append_number(list_T *const l, const varnumber_T n);  // eval/typval.c:412
list_T *tv_list_copy(const vimconv_T *const conv, list_T *const orig, const _Bool deep, const int copyID) FUNC_ATTR_WARN_UNUSED_RESULT;  // eval/typval.c:433
void tv_list_extend(list_T *const l1, list_T *const l2, listitem_T *const bef) FUNC_ATTR_NONNULL_ARG(1, 2);  // eval/typval.c:476
int tv_list_concat(list_T *const l1, list_T *const l2, typval_T *const tv) FUNC_ATTR_WARN_UNUSED_RESULT;  // eval/typval.c:499
int tv_list_join(garray_T *const gap, list_T *const l, const char *const sep) FUNC_ATTR_NONNULL_ALL;  // eval/typval.c:593
_Bool tv_list_equal(list_T *const l1, list_T *const l2, const _Bool ic, const _Bool recursive) FUNC_ATTR_WARN_UNUSED_RESULT;  // eval/typval.c:621
listitem_T *tv_list_find(list_T *const l, int n) FUNC_ATTR_PURE FUNC_ATTR_WARN_UNUSED_RESULT;  // eval/typval.c:656
varnumber_T tv_list_find_nr(list_T *const l, const int n, _Bool *const ret_error) FUNC_ATTR_WARN_UNUSED_RESULT;  // eval/typval.c:733
const char *tv_list_find_str(list_T *const l, const int n) FUNC_ATTR_WARN_UNUSED_RESULT;  // eval/typval.c:752
long tv_list_idx_of_item(const list_T *const l, const listitem_T *const item) FUNC_ATTR_WARN_UNUSED_RESULT FUNC_ATTR_PURE;  // eval/typval.c:769
void tv_dict_watcher_add(dict_T *const dict, const char *const key_pattern, const size_t key_pattern_len, Callback callback) FUNC_ATTR_NONNULL_ARG(2);  // eval/typval.c:806
_Bool tv_callback_equal(const Callback *const cb1, const Callback *const cb2) FUNC_ATTR_NONNULL_ALL FUNC_ATTR_WARN_UNUSED_RESULT;  // eval/typval.c:827
_Bool tv_dict_watcher_remove(dict_T *const dict, const char *const key_pattern, const size_t key_pattern_len, Callback callback) FUNC_ATTR_NONNULL_ARG(2);  // eval/typval.c:858
void tv_dict_watcher_notify(dict_T *const dict, const char *const key, typval_T *const newtv, typval_T *const oldtv) FUNC_ATTR_NONNULL_ARG(1, 2);  // eval/typval.c:915
dictitem_T *tv_dict_item_alloc_len(const char *const key, const size_t key_len) FUNC_ATTR_NONNULL_RET FUNC_ATTR_NONNULL_ALL FUNC_ATTR_WARN_UNUSED_RESULT FUNC_ATTR_MALLOC;  // eval/typval.c:973
dictitem_T *tv_dict_item_alloc(const char *const key) FUNC_ATTR_NONNULL_RET FUNC_ATTR_NONNULL_ALL FUNC_ATTR_WARN_UNUSED_RESULT FUNC_ATTR_MALLOC;  // eval/typval.c:991
void tv_dict_item_free(dictitem_T *const item) FUNC_ATTR_NONNULL_ALL;  // eval/typval.c:1001
void tv_dict_item_remove(dict_T *const dict, dictitem_T *const item) FUNC_ATTR_NONNULL_ALL;  // eval/typval.c:1027
dict_T *tv_dict_alloc(void) FUNC_ATTR_NONNULL_RET FUNC_ATTR_WARN_UNUSED_RESULT;  // eval/typval.c:1044
void tv_dict_free_contents(dict_T *const d) FUNC_ATTR_NONNULL_ALL;  // eval/typval.c:1070
void tv_dict_free_dict(dict_T *const d) FUNC_ATTR_NONNULL_ALL;  // eval/typval.c:1101
void tv_dict_free(dict_T *const d) FUNC_ATTR_NONNULL_ALL;  // eval/typval.c:1122
void tv_dict_unref(dict_T *const d);  // eval/typval.c:1137
dictitem_T *tv_dict_find(const dict_T *const d, const char *const key, const ptrdiff_t len) FUNC_ATTR_NONNULL_ARG(2) FUNC_ATTR_PURE FUNC_ATTR_WARN_UNUSED_RESULT;  // eval/typval.c:1153
varnumber_T tv_dict_get_number(const dict_T *const d, const char *const key) FUNC_ATTR_PURE FUNC_ATTR_WARN_UNUSED_RESULT;  // eval/typval.c:1177
char *tv_dict_get_string(const dict_T *const d, const char *const key, const _Bool save) FUNC_ATTR_WARN_UNUSED_RESULT;  // eval/typval.c:1197
const char *tv_dict_get_string_buf(const dict_T *const d, const char *const key, char *const numbuf) FUNC_ATTR_WARN_UNUSED_RESULT;  // eval/typval.c:1218
const char *tv_dict_get_string_buf_chk(const dict_T *const d, const char *const key, const ptrdiff_t key_len, char *const numbuf, const char *const def) FUNC_ATTR_WARN_UNUSED_RESULT;  // eval/typval.c:1241
_Bool tv_dict_get_callback(dict_T *const d, const char *const key, const ptrdiff_t key_len, Callback *const result) FUNC_ATTR_NONNULL_ARG(2, 4) FUNC_ATTR_WARN_UNUSED_RESULT;  // eval/typval.c:1264
int tv_dict_add(dict_T *const d, dictitem_T *const item) FUNC_ATTR_NONNULL_ALL;  // eval/typval.c:1298
int tv_dict_add_list(dict_T *const d, const char *const key, const size_t key_len, list_T *const list) FUNC_ATTR_NONNULL_ALL;  // eval/typval.c:1312
int tv_dict_add_dict(dict_T *const d, const char *const key, const size_t key_len, dict_T *const dict) FUNC_ATTR_NONNULL_ALL;  // eval/typval.c:1337
int tv_dict_add_nr(dict_T *const d, const char *const key, const size_t key_len, const varnumber_T nr);  // eval/typval.c:1362
int tv_dict_add_str(dict_T *const d, const char *const key, const size_t key_len, const char *const val) FUNC_ATTR_NONNULL_ALL;  // eval/typval.c:1385
int tv_dict_add_allocated_str(dict_T *const d, const char *const key, const size_t key_len, char *const val) FUNC_ATTR_NONNULL_ALL;  // eval/typval.c:1406
void tv_dict_clear(dict_T *const d) FUNC_ATTR_NONNULL_ALL;  // eval/typval.c:1428
void tv_dict_extend(dict_T *const d1, dict_T *const d2, const char *const action) FUNC_ATTR_NONNULL_ALL;  // eval/typval.c:1451
_Bool tv_dict_equal(dict_T *const d1, dict_T *const d2, const _Bool ic, const _Bool recursive) FUNC_ATTR_WARN_UNUSED_RESULT;  // eval/typval.c:1514
dict_T *tv_dict_copy(const vimconv_T *const conv, dict_T *const orig, const _Bool deep, const int copyID);  // eval/typval.c:1550
void tv_dict_set_keys_readonly(dict_T *const dict) FUNC_ATTR_NONNULL_ALL;  // eval/typval.c:1610
list_T *tv_list_alloc_ret(typval_T *const ret_tv) FUNC_ATTR_NONNULL_ALL;  // eval/typval.c:1629
void tv_dict_alloc_ret(typval_T *const ret_tv) FUNC_ATTR_NONNULL_ALL;  // eval/typval.c:1645
void tv_clear(typval_T *const tv);  // eval/typval.c:1890
void tv_free(typval_T *tv);  // eval/typval.c:1910
void tv_copy(typval_T *const from, typval_T *const to);  // eval/typval.c:1957
void tv_item_lock(typval_T *const tv, const int deep, const _Bool lock) FUNC_ATTR_NONNULL_ALL;  // eval/typval.c:2010
_Bool tv_islocked(const typval_T *const tv) FUNC_ATTR_PURE FUNC_ATTR_WARN_UNUSED_RESULT FUNC_ATTR_NONNULL_ALL;  // eval/typval.c:2084
_Bool tv_check_lock(const VarLockStatus lock, const char *name, size_t name_len) FUNC_ATTR_WARN_UNUSED_RESULT;  // eval/typval.c:2114
_Bool tv_equal(typval_T *const tv1, typval_T *const tv2, const _Bool ic, const _Bool recursive) FUNC_ATTR_WARN_UNUSED_RESULT FUNC_ATTR_NONNULL_ALL;  // eval/typval.c:2166
_Bool tv_check_str_or_nr(const typval_T *const tv) FUNC_ATTR_WARN_UNUSED_RESULT FUNC_ATTR_NONNULL_ALL;  // eval/typval.c:2255
_Bool tv_check_num(const typval_T *const tv) FUNC_ATTR_NONNULL_ALL FUNC_ATTR_WARN_UNUSED_RESULT;  // eval/typval.c:2314
_Bool tv_check_str(const typval_T *const tv) FUNC_ATTR_NONNULL_ALL FUNC_ATTR_WARN_UNUSED_RESULT;  // eval/typval.c:2358
varnumber_T tv_get_number(const typval_T *const tv) FUNC_ATTR_NONNULL_ALL FUNC_ATTR_WARN_UNUSED_RESULT;  // eval/typval.c:2392
varnumber_T tv_get_number_chk(const typval_T *const tv, _Bool *const ret_error) FUNC_ATTR_WARN_UNUSED_RESULT FUNC_ATTR_NONNULL_ARG(1);  // eval/typval.c:2411
linenr_T tv_get_lnum(const typval_T *const tv) FUNC_ATTR_NONNULL_ALL FUNC_ATTR_WARN_UNUSED_RESULT;  // eval/typval.c:2463
float_T tv_get_float(const typval_T *const tv) FUNC_ATTR_NONNULL_ALL FUNC_ATTR_WARN_UNUSED_RESULT;  // eval/typval.c:2484
const char *tv_get_string_buf_chk(const typval_T *const tv, char *const buf) FUNC_ATTR_NONNULL_ALL FUNC_ATTR_WARN_UNUSED_RESULT;  // eval/typval.c:2534
const char *tv_get_string_chk(const typval_T *const tv) FUNC_ATTR_NONNULL_ALL FUNC_ATTR_WARN_UNUSED_RESULT;  // eval/typval.c:2576
const char *tv_get_string(const typval_T *const tv) FUNC_ATTR_NONNULL_ALL FUNC_ATTR_NONNULL_RET FUNC_ATTR_WARN_UNUSED_RESULT;  // eval/typval.c:2599
const char *tv_get_string_buf(const typval_T *const tv, char *const buf) FUNC_ATTR_NONNULL_ALL FUNC_ATTR_NONNULL_RET FUNC_ATTR_WARN_UNUSED_RESULT;  // eval/typval.c:2621
#include "nvim/func_attr.h"
